# Contributing

Patches and contributions are generally welcome to improve this project. There are a few things to consider in order to be a productive contributor.

## Code of Conduct

This project abides by the [Contributor Covenant Code of Conduct](./CODE_OF_CONDUCT.md), which is a standard code of conduct used across the open source community. Participation of the project constitutes implicit acceptance of this covenant, and any violations will be taken seriously.

## Reporting Issues

Bugs, enhancements, and questions should be filed as issues on this repository. If you're reporting a bug, please provide as much supporting context as possible such as your operating system, Go version, and anything else that might be relevant to the bug. For anything else, explain what you're trying to achieve and what is missing from the package that you had expected to aid your efforts.

## Submitting a Pull Request

Please start by opening an issue before entering a pull request. Once your issue has been entered, you can fork the project, create a new branch on your fork, and open a pull request using that branch. Your pull request should follow our template and reference the original issue.

Pull requests are expected to pass lints, and significant changes should be accompanied with tests. Please take care when writing and formatting your commit messages, as they're often a source a clarity for the community into the nature of a change.