// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.AppPreviewSets {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/appPreviewSets/{id}`
        public let path: String

        public func get(fieldsAppPreviewSets: [FieldsAppPreviewSets]? = nil, include: [Include]? = nil, fieldsAppPreviews: [FieldsAppPreviews]? = nil, limitAppPreviews: Int? = nil) -> Request<_Specification.AppPreviewSetResponse> {
            Request(path: path, method: "GET", query: makeGetQuery(fieldsAppPreviewSets, include, fieldsAppPreviews, limitAppPreviews), id: "appPreviewSets-get_instance")
        }

        private func makeGetQuery(_ fieldsAppPreviewSets: [FieldsAppPreviewSets]?, _ include: [Include]?, _ fieldsAppPreviews: [FieldsAppPreviews]?, _ limitAppPreviews: Int?) -> [(String, String?)] {
            let encoder = URLQueryEncoder(explode: false)
            encoder.encode(fieldsAppPreviewSets, forKey: "fields[appPreviewSets]")
            encoder.encode(include, forKey: "include")
            encoder.encode(fieldsAppPreviews, forKey: "fields[appPreviews]")
            encoder.encode(limitAppPreviews, forKey: "limit[appPreviews]")
            return encoder.items
        }

        public enum FieldsAppPreviewSets: String, Codable, CaseIterable {
            case appCustomProductPageLocalization
            case appPreviews
            case appStoreVersionExperimentTreatmentLocalization
            case appStoreVersionLocalization
            case previewType
        }

        public enum Include: String, Codable, CaseIterable {
            case appCustomProductPageLocalization
            case appPreviews
            case appStoreVersionExperimentTreatmentLocalization
            case appStoreVersionLocalization
        }

        public enum FieldsAppPreviews: String, Codable, CaseIterable {
            case appPreviewSet
            case assetDeliveryState
            case fileName
            case fileSize
            case mimeType
            case previewFrameTimeCode
            case previewImage
            case sourceFileChecksum
            case uploadOperations
            case uploaded
            case videoURL = "videoUrl"
        }

        public var delete: Request<Void> {
            Request(path: path, method: "DELETE", id: "appPreviewSets-delete_instance")
        }
    }
}
